/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   MotionDetector.h
 * Author: Martin Kjellqvist <martin.kjellqvist@miun.se>
 *
 * Created on March 18, 2018, 12:53 PM
 */

#ifndef MOTIONDETECTOR_H
#define MOTIONDETECTOR_H
#include <gdkmm-3.0/gdkmm/event.h>
#include <cmath>

struct MotionDetector {
    guint32 start = 0;
    gdouble startx = 0;
    gdouble starty = 0;

    enum Direction {
        UP, DOWN, LEFT, RIGHT
    };

    /**
     * double pixels per millisecond
     * */

    using Callback = std::function<void(gdouble, gdouble, Direction, double) >;

    MotionDetector() {

    }

    bool operator()(GdkEventMotion* motion) {
        // start/first click
        if ((motion->state & GDK_BUTTON1_MASK) && !start) {
            startx = motion->x;
            starty = motion->y;
            start = motion->time;
        }
        // release
        if (start && (!(motion->state & GDK_BUTTON1_MASK))) {
            auto diffx = std::fabs(startx - motion->x);
            auto diffy = std::fabs(starty - motion->y);
            Direction d = RIGHT;
            double speed = diffx;
            
            if (diffx > diffy) {
                if (motion->x < startx)
                    d = LEFT;
            } else {
                speed = diffy;
                if (motion->y < starty)
                    d = UP;
                else
                    d = DOWN;
            }
            auto time_diff = (motion->time - start);
            speed /= time_diff;

            // reset 
            start = 0;
            if (time_diff > 100)
                callback(startx, starty, d, speed);

        }
        return true;
    }
    Callback callback;
};

#endif /* MOTIONDETECTOR_H */

