/* 
 * File:   Tile.cpp
 * Author: martin
 * 
 * Created on February 12, 2018, 2:04 PM
 */

#include "Tile.h"
#include <exception>
#include <iostream>

Tile::Tile(TileType tiletype) : type(tiletype) {
}

Gtk::ChildPropertyProxy<int> Tile::property_x() {
    return get_parent()->child_property_x(*this);
}

Gtk::ChildPropertyProxy<int> Tile::property_y() {
    return get_parent()->child_property_y(*this);
}

Gtk::Fixed* Tile::get_parent() {
    auto parent = dynamic_cast<Gtk::Fixed*> (Gtk::Image::get_parent());
    if (!parent) {
        throw null_parent("Widget has no parent, while being asked for a parent property,\n"
                "Tile::property_\n");
    }
    return parent;
}

int Tile::get_row_span() const {
    switch(type){
        case VERTICAL: return 2;
        case HORIZONTAL: return 1;
        case BIG: return 2;
        case SQUARE: return 1;
        case EMPTY: return 1;
    }
    return 0;
}

int Tile::get_col_span() const {
    switch(type){
        case VERTICAL: return 1;
        case HORIZONTAL: return 2;
        case BIG: return 2;
        case SQUARE: return 1;
        case EMPTY: return 1;
    }
    return 0;
}

TileType Tile::get_tile_type() const {
    return type;
}

null_parent::null_parent(const std::string& __arg) :
    runtime_error(__arg) {
}
